*! version 2.0.4  21jun2006  by Marc Muendler muendler@ucsd.edu

capture program drop corr2tex
program define corr2tex
    version 8.2
    syntax [varlist] [if] [in] [pweight fweight] [, Path(string) Name(string) FANCY REPLACE]
    if "`weight'"~="" {
        local wghtopt = "[`weight'`exp']"
        }
    matrix accum `name' = `varlist' `if' `in' `wghtopt', nocons dev
    matrix `name' = corr(`name')
    mat rename `name' `name'_tbl
    mat list `name'_tbl
    disp
    est2tex `name', ready `replace' preserve path(`path') `fancy'
end

capture program drop summ2tex
program define summ2tex
    version 8.2
    syntax [varlist] [if] [in] [pweight fweight] [, C(string) Path(string) Name(string) FANCY REPLACE DETAIL]
    if "`weight'"~="" {
        local wghtopt = "[`weight'`exp']"
        }
    local cols : word count `c'
    mat `name' = J(1,`cols',.)
    matname `name' `c', columns(1..`cols') explicit
    tempname matrow
    local i = 0
    foreach var of varlist `varlist' {
        local i = `i' + 1
        local var = trim(subinstr("`var'",`","',"",.))
        qui summ `var' `if' `in' `wghtopt', `detail'
        mat `matrow' = J(1,`cols',.)
        matname `matrow' `var', rows(1) explicit
        local j = 0
        foreach type in `c' {
            local j = `j' + 1
            capture local chk = `r(`type')'
            if _rc==0 {
                mat `matrow'[1,`j'] = `r(`type')'
                }
            }
        mat `name' = `name' \ `matrow'
    }
    local rows = rowsof(`name')
    mat `name' = `name'[2..`rows',1..`cols']
    mat rename `name' `name'_tbl
    mat list `name'_tbl
    disp
    est2tex `name', ready `replace' preserve path(`path') `fancy'
end

capture program drop tabl2tex
program define tabl2tex
    * NOTE: TOTALS ARE STILL UNWEIGHTED, NO PROPER AVERAGES ARE PRODUCED
    * USE SUMM FUNCTION IN FUTURE TO CALCULATE MARGINALS
    * ALTERS DATA IN MEMORY
    * CONSIDER TREATMENT OF MISSING VALUES AND CW OPTION
    version 8.2
    syntax [varlist] [if] [in] [pweight fweight] [, Type(string) Rowvar(varname) Colvar(varname) ROWLabel(string) COLLabel(string) Path(string) Name(string) NOTOTal FANCY REPLACE NOLOG PREcision(real 0) DIGits(integer 3) CATegories(string) OVERwrite VALLABels(string) FLExible(integer 2) DOTs LEADZERO THOUSEP SCALe(real 1)]
    args var
    capture local chk = rowsof(`name'_tbl)
    if _rc==0 & "`overwrite'"=="" {
      disp as err "matrix `name'_tbl already defined"
      exit 110
      }
    capture mat drop `name'_tbl
    if `digits'~=float(0) & `precision'~=float(0) {
      disp as err "digits() and precision() invalid"
      exit 198
      }
    if "`categories'"~="" {
      local nolog = "nolog"
      qui summ `rowvar'
      if `r(min)'~=`r(max)' {
        disp as err "`rowvar' must take unique value with option categories()"
        exit 134
        }
      }
    if `precision'~=0  local digits = length(string(`precision'))-1
    if "`type'"=="count"  local digits 0
    local var = trim(subinstr("`var'",`","',"",.))
    if ("`type'"=="sum" | "`type'"=="count") & "`nototal'"==""  local totopt = "row col"
    if "`weight'"~=""  local wghtopt = "[`weight'`exp']"
    * disp "`var': table `rowvar' `colvar' `if' `in' `wghtopt', c(`type' `var') `totopt'"
    * disp "`var': collapse (`type') `var' `if' `in' `wghtopt', by(`rowvar' `colvar') fast cw"
    confirm numeric variable `rowvar' `colvar'
    if "`nolog'" == "" {
        table `rowvar' `colvar' `if' `in' `wghtopt', c(`type' `var') `totopt'
        }
    collapse (`type') `var' `if' `in' `wghtopt', by(`rowvar' `colvar') fast cw
    foreach colrow in col row {
      if "``colrow'label'" == "" {
        local `colrow'label : value label ``colrow'var'
        if "``colrow'label'" == "" {
            tempname lblnam
            qui count
            forvalues i = 1/`r(N)' {
                local lbltit = ``colrow'var'[`i']
                capture label define `lblnam' `lbltit' "`lbltit'", modify  /* capture averts label for missing */
                }
             local `colrow'label = "`lblnam'"
             }
           }
      label values ``colrow'var' ``colrow'label'
      }
    tempfile collblf
    qui label save `collabel' using `collblf'.do, replace
    if "`categories'"~="" {
      qui reshape long `categories', i(year) j(_tmpvar) string
      drop `rowvar'
      encode _tmpvar, gen(`rowvar')
      drop _tmpvar
      local var `categories'
      }
    rename `var' `var'_
    qui reshape wide `var'_, i(`rowvar') j(`colvar')
    qui duplicates drop
    rename `rowvar' _rowname
    * PRESENT TREATMENT OF MISSING: DROP
    qui drop if _rowname==.
    if "`totopt'" ~= "" {
      local rtype = "`type'"
      if "`type'"=="count" {
        local rtype = "sum"
        }
      egen _total = r`rtype'(`var'_*)
      * ADJUST THIS LINE FOR WEIGHTED SUMS
      qui count
      local newobs = `r(N)' + 1
      qui set obs `newobs'
      qui summ _rowname
      local totlno = .
      qui replace _rowname = `totlno' in `newobs'
      capture label define `rowlabel' `totlno' "_total", modify
      foreach jvar of varlist `var'_* _total {
        qui summ `jvar', meanonly
        if `r(N)' > 0 {
            qui replace `jvar' = `r(`rtype')' in `newobs'
            }
        }
      }
    qui do `collblf'.do
    erase `collblf'.do
    foreach jvar of varlist `var'_* {
        local cntr = substr("`jvar'",-index(reverse("`jvar'"),"_")+1,length("`jvar'")-index(reverse("`jvar'"),"_"))
        * disp "`cntr'"
        local jvarnam : label `collabel' `cntr'
        * disp "`jvarnam'"
        capture rename `jvar' `jvarnam'
        }
    decode _rowname, gen(`rowvar')
    drop _rowname
    rename `rowvar' _rowname
    order _rowname
    qui replace _rowname = substr(_rowname,1,20)
    qui replace _rowname = subinstr(_rowname," ","_",.)
    qui replace _rowname = subinstr(_rowname,";","_",.)
    qui replace _rowname = subinstr(_rowname,",","_",.)
    qui replace _rowname = subinstr(_rowname,".","_",.)
    qui replace _rowname = subinstr(_rowname,":","_",.)
    qui replace _rowname = subinstr(_rowname,"!","_",.)
    qui replace _rowname = subinstr(_rowname,"-","_",.)
    qui replace _rowname = "_" if _rowname==""
    qui compress
    tempname tmpname
    qui save `path'/`tmpname'_tbl, replace
    qui matload `tmpname'_tbl, p(`path') over dropall missing(.)
    local erasfile = subinstr("`path'" + "\" + "`tmpname'_tbl.dta","/",`"\"',.)
    erase `erasfile'
    mat rename `tmpname'_tbl `name'_tbl

    mat `name'_tbl = `scale' * `name'_tbl
    est2tex `name', ready `replace' preserve path(`path') `fancy' digits(`digits') vallabels(`vallabels') flexible(`flexible') `dots' `leadzero' `thousep'
end

capture program drop ta2tex
program define ta2tex, rclass byable(recall) sort
    version 8.2
    syntax varlist [if] [in] [, Row COLumn Matrix(string) Path(string) REPLACE FANCY VALLABels(string) PREcision(real 0) DIGits(integer 3) FLExible(integer 2) DOTs LEADZERO THOUSEP SCALe(real 1)]
    tempname `matrix' rowtot coltot rowsum colsum matrow matcol
    
    local cnt : word count `varlist'
    if `cnt'<2 {
      error 102
      }
    if `cnt'>2 {
      error 103
      }
    confirm numeric variable `varlist'
    if `digits'~=float(0) & `precision'~=float(0) {
      disp as err "digits() and precision() invalid"
      exit 198
      }
    if `precision'~=0 {
        local precision = `precision' - int(`precision')
        local digits = length(string(`precision'))-1
        }
    if `digits'~=0 {
      local precision = 10^(-`digits')
      }
    if "`vallabels'"~="" {
      qui do "`path'/`vallabels'"
      label values `varlist' `vallabels'
      }

    tempvar touse
    mark `touse' `if' `in'
    markout `touse' `varlist'

    if "`row'"=="" & "`column'"==""  ta `varlist' if `touse', freq matcell(``matrix'') matrow(`matrow') matcol(`matcol')
    if "`row'"=="row"                ta `varlist' if `touse', row nofreq nokey matcell(``matrix'') matrow(`matrow') matcol(`matcol')
    if "`column'"=="column"          ta `varlist' if `touse', col nofreq nokey matcell(``matrix'') matrow(`matrow') matcol(`matcol')
    ret add

    // create output matrix
    local matrows = rowsof(``matrix'')
    local matcols = colsof(``matrix'')
    mat `rowsum' = ``matrix'' * J(`matcols',1,1)
    mat `colsum' = J(1,`matrows',1) * ``matrix''
    mat `rowtot' = J(1,`matrows',1) * `rowsum'
    mat `coltot' = `colsum' * J(`matcols',1,1)
    if "`row'"=="" & "`column'"==""  mat ``matrix'' = ( ``matrix'' \ `colsum' ) , ( `rowsum' \ `coltot' )
    if "`row'"=="row" {
      forvalues col=1/`matcols' {
        forvalues row=1/`matrows' {
          mat ``matrix''[`row',`col'] = ``matrix''[`row',`col'] / `rowsum'[`row',1]
          }
        mat `colsum'[1,`col'] = `colsum'[1,`col'] / `coltot'[1,1]
        }
      mat ``matrix'' = ( ``matrix'' \ `colsum' ) , J(`matrows'+1,1,1)
      }
    if "`column'"=="column" {
      forvalues row=1/`matrows' {
        forvalues col=1/`matcols' {
          mat ``matrix''[`row',`col'] = ``matrix''[`row',`col'] / `colsum'[1,`col']
          }
        mat `rowsum'[`row',1] = `rowsum'[`row',1] / `rowtot'[1,1]
        }
      mat ``matrix'' = ( ``matrix'' , `rowsum' ) \ J(1,`matcols'+1,1)
      }

    // label output matrix
    tokenize `varlist'
    local colnames ""
    forvalues col=1/`matcols' {
      local `matcol' = `matcol'[1,`col']
      local colnames "`colnames' `2'_``matcol''"
      }
    matname ``matrix'' `colnames', columns(1..`matcols') explicit
    local rownames ""
    forvalues row=1/`matrows' {
      local `matrow' = `matrow'[`row',1]
      local rownames "`rownames' `1'_``matrow''"
      }
    matname ``matrix'' `rownames', rows(1..`matrows') explicit
    local totrows = rowsof(``matrix'')
    local totcols = colsof(``matrix'')
    if "`vallabels'"==""  matname ``matrix'' total, rows(`totrows') explicit
    else                  matname ``matrix'' Total, rows(`totrows') explicit
    matname ``matrix'' total, columns(`totcols') explicit
    
    mat `matrix'_tbl = `scale' * ``matrix''
    est2tex `matrix', ready `replace' preserve path(`path') `fancy' vallabels(`vallabels') digits(`digits') flexible(`flexible') `dots' `leadzero' `thousep'
end

capture program drop xttrans2tex
program define xttrans2tex, rclass byable(recall) sort
    version 8.2
    syntax varname [if] [in] [, I(varname) T(varname) Matrix(string) Path(string) REPLACE FANCY COUNTs VALLABels(string) PREcision(real 0) DIGits(integer 3) FLExible(integer 2) DOTs LEADZERO THOUSEP SCALe(real 1)]
    tempname `matrix' coltot rowsum colsum matrow matcol
    
    local cnt : word count `varlist'
    if `cnt'>1 {
      error 103
      }
    confirm numeric variable `varlist'
    if `digits'~=float(0) & `precision'~=float(0) {
      disp as err "digits() and precision() invalid"
      exit 198
      }
    if `precision'~=0 {
        local precision = `precision' - int(`precision')
        local digits = length(string(`precision'))-1
        }
    if `digits'~=0 {
      local precision = 10^(-`digits')
      }
    if "`vallabels'"~="" {
      qui do "`path'/`vallabels'"
      label values `varlist' `vallabels'
      }

    xt_iis `i'
    local ivar "`s(ivar)'"
    xt_tis `t'
    local tvar "`s(timevar)'"

    tempvar touse
    mark `touse' `if' `in'
    markout `touse' `varlist' `ivar' `tvar'

    // replicate xttrans
    tempvar was is
    quietly { 
        sort `ivar' `tvar' 
        by `ivar': gen float `was' = `varlist' if _n<_N
        by `ivar': gen float `is'  = `varlist'[_n+1] if _n<_N
        local lbl : var label `varlist'
        if "`lbl'"==""  local lbl "`varlist'"
        label var `was' "`lbl'"  
        label var `is' "`lbl'"
        by `ivar': replace `touse'=0 if `touse'[_n+1]==0 & _n<_N
        }
    if "`counts'"==""  tabulate `was' `is' if `touse', row nofreq nokey matcell(``matrix'') matrow(`matrow') matcol(`matcol')
    else               tabulate `was' `is' if `touse', freq nokey matcell(``matrix'') matrow(`matrow') matcol(`matcol')
    ret add
    
    // create output matrix
    local matrows = rowsof(``matrix'')
    local matcols = colsof(``matrix'')
    mat `rowsum' = ``matrix'' * J(`matcols',1,1)
    mat `colsum' = J(1,`matrows',1) * ``matrix''
    mat `coltot' = `colsum' * J(`matcols',1,1)
    if "`counts'"=="" {
      forvalues col=1/`matcols' {
        forvalues row=1/`matrows' {
          mat ``matrix''[`row',`col'] = ``matrix''[`row',`col'] / `rowsum'[`row',1]
          }
        mat `colsum'[1,`col'] = `colsum'[1,`col'] / `coltot'[1,1]
        }
      mat ``matrix'' = ( ``matrix'' \ `colsum' ) , J(`matrows'+1,1,1)
      }
    else {
      mat ``matrix'' = ( ``matrix'' \ `colsum' ) , ( `rowsum' \ `coltot' )
      }

    // label output matrix
    if "`vallabels'"=="" {
      local colnames ""
      forvalues col=1/`matcols' {
        local `matcol' = `matcol'[1,`col']
        local colnames "`colnames' `varlist'_``matcol''"
        }
      matname ``matrix'' `colnames', columns(1..`matcols') explicit
      }
    else {
      local colnames ""
      forvalues col=1/`matcols' {
        local `matcol' = `matcol'[1,`col']
        local addname : label `vallabels' ``matcol''
        local addname = subinstr(subinstr(subinstr("`addname'"," ","",.),".","",.),"/","_",.)
        local addname = substr(trim(lower("`addname'")),1,7)
        local colnames "`colnames' `addname'"
        }
      matname ``matrix'' `colnames', columns(1..`matcols') explicit
      }
    local rownames ""
    forvalues row=1/`matrows' {
      local `matrow' = `matrow'[`row',1]
      local rownames "`rownames' ``matrow''"
      }
    matname ``matrix'' `rownames', rows(1..`matrows') explicit
    local totrows = rowsof(``matrix'')
    local totcols = colsof(``matrix'')
    if "`vallabels'"==""  matname ``matrix'' total, rows(`totrows') explicit
    else                  matname ``matrix'' Total, rows(`totrows') explicit
    matname ``matrix'' total, columns(`totcols') explicit
    
    mat `matrix'_tbl = `scale' * ``matrix''
    est2tex `matrix', ready `replace' preserve path(`path') `fancy' vallabels(`vallabels') digits(`digits') flexible(`flexible') `dots' `leadzero' `thousep'
end

